package de.fraunhofer.iem.dataprovider.dependency.service

import de.fraunhofer.iem.dataprovider.dependency.dto.DependencyCreateDto
import de.fraunhofer.iem.dataprovider.dependency.entity.DependencyEntity
import de.fraunhofer.iem.dataprovider.dependency.repository.DependencyRepository
import de.fraunhofer.iem.dataprovider.logger.getLogger
import org.springframework.stereotype.Service
import java.util.*

@Service
class DependencyService(private val dependencyRepository: DependencyRepository) {

    private val logger = getLogger(javaClass)
    fun save(dependencyEntity: DependencyEntity) {
        dependencyRepository.save(dependencyEntity)
    }

    fun getDependenciesForRepository(repoId: UUID): List<DependencyCreateDto> {
        // TODO: Refactor the type of dependencycreatdto
        return dependencyRepository.findByRepositories_Id(repoId).map { it.toDto() }
    }

//    fun getMaximalDependencyVulnerabilityScore(repoId: UUID): Pair<Int, List<DependencyEntity>> {
//        val dependencies = getDependenciesForRepository(repoId)
//        var highestScore = 0.0
//        dependencies.forEach { dependency ->
//            dependency.vulnerabilities.forEach { vulnerability ->
//                vulnerability.vulnerabilityScores.forEach { score ->
//                    if (score.scoringSystem != null && score.scoringSystem == VulnerabilityScoringSystemEnum.CVSSV3) {
//                        try {
//                            val severity = score.severity?.toDouble()
//                            if (severity != null && severity > highestScore) {
//                                highestScore = severity
//                            }
//                        } catch (e: Throwable) {
//                            logger.error("Parsing from severity to double failed. $e")
//                        }
//                    }
//                }
//            }
//        }
//        return Pair((highestScore * 10.0).toInt(), dependencies)
//    }
}