package de.fraunhofer.iem.dataprovider.taskManager.tasks.tools.odc

import de.fraunhofer.iem.dataprovider.taskManager.events.Event
import de.fraunhofer.iem.dataprovider.taskManager.tasks.tools.sarif.SarifTask
import de.fraunhofer.iem.dataprovider.toolRun.service.ToolRunService
import org.springframework.core.io.ClassPathResource
import org.springframework.core.io.Resource
import java.nio.file.Path
import java.nio.file.Paths
import java.util.*

class OdcTask(
    repositoryDirectoryPath: String,
    outputDirectoryPath: String,
    override val responseChannel: suspend (task: Event) -> Unit,
    override val repoId: UUID,
    override val groupID: UUID? = null,
    override val toolRunService: ToolRunService
) : SarifTask() {

    private val resource: Resource = ClassPathResource("scripts/odc.sh")
    override val outputDirectory = Paths.get(outputDirectoryPath, "odc", taskID.toString()).toString()
    override val flags: Array<String> = arrayOf(resource.file.absolutePath, outputDirectory, repositoryDirectoryPath)
    override val resultFileOutputPath: Path = Paths.get(outputDirectoryPath, "odc", "dependency-check-report.sarif")
}
